# NaiveTicket

The second Objects lab,from the BlueJ book's second chapter.

Look for the [Chapter 2 file](./doc/BlueJ-objects-first-ch2.pdf) you need in the [doc](./doc) folder. There is 35 pages of reading and exercises in the chapter.

Work through all these exercises. You edit this file with your answers for these exercises.

* Exercise 2.1 Create a TicketMachine object on the object bench and take a look
at its methods. You should see the following: getBalance, getPrice, insertMoney,
and printTicket. Try out the getPrice method. You should see a return value containing
the price of the tickets that was set when this object was created. Use the
insertMoney method to simulate inserting an amount of money into the machine and
then use getBalance to check that the machine has a record of the amount inserted.
You can insert several separate amounts of money into the machine, just like you might
insert multiple coins or notes into a real machine. Try inserting the exact amount
required for a ticket. As this is a simple machine, a ticket will not be issued automatically,
so once you have inserted enough money, call the printTicket method. A
facsimile ticket should be printed in the BlueJ terminal window.

* Exercise 2.2 What value is returned if you check the machine’s balance after it
has printed a ticket?

The value is always zero regardless of the amount of money added.

* Exercise 2.3 Experiment with inserting different amounts of money before printing
tickets. Do you notice anything strange about the machine’s behavior? What happens
if you insert too much money into the machine – do you receive any refund? What
happens if you do not insert enough and then try to print a ticket?

The machine does not check to see if the amount of money entered is enough to cover the price of the ticket.  It also does not issue a refund.

* Exercise 2.4 Try to obtain a good understanding of a ticket machine’s behavior by
interacting with it on the object bench before we start looking at how the
TicketMachine class is implemented in the next section.

* Exercise 2.5 Create another ticket machine for tickets of a different price. Buy a
ticket from that machine. Does the printed ticket look different?

Nope!

* Exercise 2.6 Write out what you think the outer wrappers of the Student and
LabClass classes might look like – do not worry about the inner part.

public class Student{
}

public class LabClass{
}

* Exercise 2.7 Does it matter whether we write
`public class TicketMachine`
or
`class public TicketMachine`
in the outer wrapper of a class? Edit the source of the TicketMachine class to
make the change and then close the editor window. Do you notice a change in the
class diagram?
What error message do you get when you now press the Compile button? Do you think
this message clearly explains what is wrong?

It does matter! If you switch public and class, you receive an error message that says "invalid method declaration; return type required."

* Exercise 2.8 Check whether or not it is possible to leave out the word public
from the outer wrapper of the TicketMachine class.

Yup! It is possible, no error messages.

* Exercise 2.9 From your earlier experimentation with the ticket machine objects
within BlueJ you can probably remember the names of some of the methods –
printTicket, for instance. Look at the class definition in Code 2.1 and use this
knowledge, along with the additional information about ordering we have given you,
to try to make a list of the names of the fields, constructors, and methods in the
TicketMachine class. Hint: There is only one constructor in the class.

Fields: price, balance, total  Methods: getPrice(), getBalance(), insertMoney(), printTicket() Constructor: public TicketMachine(int ticketCost)

Exercise 2.10 Do you notice any features of the constructor that make it significantly
different from the other methods of the class?

It has the same name as the class and it does not have a datatype listed after public.

* Exercise 2.11 What do you think is the type of each of the following fields?
```
private int count; Integer
private Student representative; String
private Server host; String
```
* Exercise 2.12 What are the names of the following fields?
```
private boolean alive; alive
private Person tutor; tutor
private Game game; game
```
* Exercise 2.13 In the following field declaration from the TicketMachine class
```
private int price;
```
does it matter which order the three words appear in? Edit the TicketMachine class to
try different orderings. After each change, close the editor. Does the appearance of the
class diagram after each change give you a clue as to whether or not other orderings are
possible? Check by pressing the Compile button to see if there is an error message.
Make sure that you reinstate the original version after your experiments!

Yes, the order of the words do matter.  The editor gives you a sqwiggly line and a red block next to the line number.

* Exercise 2.14 Is it always necessary to have a semicolon at the end of a field declaration?
Once again, experiment via the editor. The rule you will learn here is an
important one, so be sure to remember it.

Yup!

* Exercise 2.15 Write in full the declaration for a field of type int whose name is
status.

int status;

* Exercise 2.16 To what class does the following constructor belong?
```
public Student(String name)
```
The constructor belongs to the Student class.

* Exercise 2.17 How many parameters does the following constructor have and what are their types?
```
public Book(String title, double price)
```
The constructor has two parameters. One parameter is a string, the other is a double.

* Exercise 2.18 Can you guess what types some of the Book class’s fields might be? Can you assume anything about the names of its fields?

Title and price will most likely be fields.  

EXERCISE 2.19- public Pet(String petsName)
{
  name = petsName;
}

EXERCISE 2.21- getBalance returns a value of 0. getPrice returns the the cost of the ticket, which is passed through by the user.

EXERCISE 2.22- Currently, the balance is always zero.  However, it should be characterized as- what is the difference between the price and amount paid?

EXERCISE 2.23- Nope!

EXERCISE 2.25- error found in classes

EXERCISE 2.26- printTicket does not have a return type defined.

EXERCISE 2.27- No, they do not have return statements.  They are updating variables within the object, not generating information for the user.

EXERCISE 2.29- It has a return type value.  Constructors do not.

EXERCISE 2.31- score = points + score;

EXERCISE 2.32- price = price - amount;

EXERCISE 2.35- They show different outputs.  They are two different objects, so they only inherited the methods from the class, not the field values.

EXERCISE 2.36- # price cents.

EXERCISE 2.37- # price cents.

EXERCISE 2.38-  Nope. In both the word price will be treated as a string not the variable price because it is enclosed in quotes.

Exercise 2.39- The ticket price is no longer a field that is updated by the user.  

Exercise 2.40- mutator

Exercise 2.41-

EXERCISE 2.42-

EXERCISE 2.43- The balance does not change when an error message occurs.  I received the error message when I entered 0.

EXERCISE 2.44- No error message will be received, and the balance will be 0.

EXERCISE 2.45- The feature was isVisible.  Yes, booleans were well suited because there are only two options- visible or invisible.

EXERCISE 2.47- The field can never be negative.  The conditional statement ensures that the balance is always greater than or equal to the price.  Therefore, if the balance is subtracted from the price, the new balance must be positive.

EXERCISE 2.49-

EXERCISE 2.50-

EXERCISE 2.51-

EXERCISE 2.52-

EXERCISE 2.53- The balance is set to zero, so the returned balance value will always be zero.  Whereas the original is returning the remaining balance (which is calculated in the printTicket method and stored in the local variable amountToRefund), then setting the balance to 0.

EXERCISE 2.54- No further statements are run after the return statement and the variable with the value is located after the return statement.

EXERCISE 2.56- It is a mutator method, even though the value of total is already 0.


Work all Exercises from 2.19 to 2.58 that are NOT marked *Challenge exercise*.
READ upto and INCLUDING section 2.15 of this chapter.
